package com.yunyan.common.utils;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.yunyan.common.constant.HttpStatus;
import com.yunyan.common.core.page.PageDomain;
import com.yunyan.common.core.page.TableDataInfo;
import com.yunyan.common.core.page.TableSupport;
import com.yunyan.common.utils.sql.SqlUtil;

import java.util.List;

/**
 * 分页工具类
 *
 * @author yunyan
 */
public class PageUtils extends PageHelper
{
    /**
     * 设置请求分页数据
     */
    public static void startPage()
    {
        PageDomain pageDomain = TableSupport.buildPageRequest();
        Integer pageNum = pageDomain.getPageNum();
        Integer pageSize = pageDomain.getPageSize();
        String orderBy = SqlUtil.escapeOrderBySql(pageDomain.getOrderBy());
        Boolean reasonable = pageDomain.getReasonable();
        PageHelper.startPage(pageNum, pageSize, orderBy).setReasonable(reasonable);
    }

    /**
     * 清理分页的线程变量
     */
    public static void clearPage()
    {
        PageHelper.clearPage();
    }

    /**
     * 分页 List(非Page) 的异常时调用, 如 查询后转 vo 的List
     * @param list 转换后的list
     * @param pageList 查询分页的 page类型的list
     * @return
     */
    public static TableDataInfo getDataTable(List<?> list, List<?> pageList)
    {
        TableDataInfo rspData = new TableDataInfo();
        rspData.setCode(HttpStatus.SUCCESS);
        rspData.setMsg("查询成功");
        rspData.setRows(list);
        rspData.setTotal(new PageInfo(pageList).getTotal());
        rspData.setPages(new PageInfo(pageList).getPages());
        return rspData;
    }

}
